'use strict';

var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var react_exports = {};
__export(react_exports, {
  create: () => create,
  useStore: () => useStore
});
module.exports = __toCommonJS(react_exports);
var import_react = __toESM(require("react"));
var import_vanilla = require("./vanilla.ts");
const { useDebugValue, useMemo, useSyncExternalStore } = import_react.default;
const identity = (arg) => arg;
const useMemoSelector = (getState, selector) => useMemo(() => {
  let prev;
  return () => {
    const state = getState();
    if (!prev || !Object.is(prev[0], state)) {
      prev = [state, selector(state)];
    }
    return prev[1];
  };
}, [getState, selector]);
function useStore(api, selector = identity) {
  const slice = useSyncExternalStore(
    api.subscribe,
    useMemoSelector(api.getState, selector),
    useMemoSelector(api.getInitialState, selector)
  );
  useDebugValue(slice);
  return slice;
}
const createImpl = (createState) => {
  const api = (0, import_vanilla.createStore)(createState);
  const useBoundStore = (selector) => useStore(api, selector);
  Object.assign(useBoundStore, api);
  return useBoundStore;
};
const create = (createState) => createState ? createImpl(createState) : createImpl;
